% functionality of the program
function ellipse_draw
% the program creates the ellipses for the reflection symmetry axes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% the left click on the mouse can be used to create the ellipse
% the rigth click on the mouse is used to choose the ellipse created by the
% left click
% the middle click on the mouse (Shift + left click, in most laptops) is
% used to exit the current set of images and save the work done until that
% point
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear
close all



% path = './../Real_data_set/Real_single/';
gt_results_mat='small_pramod.mat';
load(cat(2,'./',gt_results_mat));
path = './../../../Random/few_good_images/'; 

% process_id='rm';
% 
% 
% if (strcmp(process_id,'ss'))  % synthetic single
%     path = './../Synthetic_Data_Set/Synthetic_single/'; 
%     gt_results_mat='GT_points.mat';
%     load(strcat(path,'GT/',gt_results_mat));
%     new_cell_gt=data_cell_GT;
% 
% elseif (strcmp(process_id,'sm')) % synthetic multiple
%     path = './../Synthetic_Data_Set/Synthetic_multiple/';
%     gt_results_mat='GT_points.mat';
%     load(strcat(path,'GT/',gt_results_mat));
%     new_cell_gt=new_data_cell_GT;
% 
% elseif (strcmp(process_id,'rs')) % real single
%     path = './../Real_data_set/Real_single/';
%     gt_results_mat='GT_points.mat';
%     load(strcat(path,'GT/',gt_results_mat));
%     new_cell_gt=cell_gt;
% elseif (strcmp(process_id,'rm')) % real multiple
%     path = './../Real_data_set/Real_multiple/';
%     gt_results_mat='GT_points.mat';
%     load(strcat(path,'GT/',gt_results_mat));
%     new_cell_gt=data_cell_GT;
% end





size_image_database=size(new_cell_gt,1);


unit_circle=[cosd(0:5:360)' sind(0:5:360)'];


for i=1:size_image_database

    try
        image_data=imread(strcat(path,new_cell_gt{i,1}));
    catch
        hold_err=lasterror;
        disp(hold_err.message)
        continue;
    end

    size(image_data)

    num_of_lines=size(new_cell_gt{i,2},1);
    hold_ends=new_cell_gt{i,2};



    for j=1:num_of_lines

        mid_point_line=[(hold_ends(j,1)+hold_ends(j,3))/2,(hold_ends(j,2)+hold_ends(j,4))/2];
        prll_vect=[hold_ends(j,3)-hold_ends(j,1),hold_ends(j,4)-hold_ends(j,2)];
        prll_vect=prll_vect./sqrt((prll_vect(1)).^2+(prll_vect(2)).^2);
        perp_vect=[-prll_vect(2),prll_vect(1)];
        %         if ((prll_vect(2)/prll_vect(1))>0)
        angle_major_axes = atand((prll_vect(2)/prll_vect(1)));
        %         else
        %             angle_major_axes = atand(abs(prll_vect(2)/prll_vect(1))) + 180;
        %         end
        major_axes_len=(sqrt((hold_ends(j,1)-hold_ends(j,3)).^2+(hold_ends(j,2)-hold_ends(j,4)).^2))/2;



        count_clicks=0;
        mouse_click=1;
        close
        imagesc(image_data)
        hold on
        plot([hold_ends(j,1) hold_ends(j,3)],[hold_ends(j,2) hold_ends(j,4)],...
            'LineWidth',3,'Color',[0 1 0])
        plot(mid_point_line(1),mid_point_line(2),'ro')

        while (mouse_click==1)

            [x,y,mouse_click] = ginput(1);
            %             mouse_click

            if (mouse_click==1)

                hypo_vect=[x-mid_point_line(1),y-mid_point_line(2)];
                hypo_dist_sqrd=(sum(hypo_vect.*hypo_vect));
                adja_vect=hypo_vect.*prll_vect;
                adja_dist_sqrd=sum(adja_vect.*adja_vect);
                perp_dist=sqrt(hypo_dist_sqrd-adja_dist_sqrd);
                end_points1=mid_point_line+perp_dist*(perp_vect);
                end_points2=mid_point_line-perp_dist*(perp_vect);
                count_clicks=count_clicks+1;
                minor_axes_len=sqrt((end_points1(1)-mid_point_line(1))^2+(end_points1(2)-mid_point_line(2))^2);
                elong_circle=unit_circle;
                elong_circle(:,1)=elong_circle(:,1)*major_axes_len;
                elong_circle(:,2)=elong_circle(:,2)*minor_axes_len;
                final_circle_x=elong_circle(:,1)*cosd(-angle_major_axes)+elong_circle(:,2)*sind(-angle_major_axes);
                final_circle_y=-elong_circle(:,1)*sind(-angle_major_axes)+elong_circle(:,2)*cosd(-angle_major_axes);


                if (count_clicks==1)

                    circle_hand=plot(final_circle_x+mid_point_line(1),final_circle_y+mid_point_line(2),'r');
                    ep1=plot(end_points1(1),end_points1(2),'go');
                    ep2=plot(end_points2(1),end_points2(2),'go');

                else

                    set(circle_hand,'XData',final_circle_x+mid_point_line(1),'YData',final_circle_y+mid_point_line(2))
                    set(ep1,'XData',end_points1(1),'YData',end_points1(2))
                    set(ep2,'XData',end_points2(1),'YData',end_points2(2))
                end

            end

        end
        if (mouse_click==2)
            break
        end


        new_cell_gt{i,2}(j,5:8)=[end_points1(1) end_points1(2) end_points2(1) end_points2(2)];


    end

    if (mouse_click==2)
        break
    end

    %     input('Press key to continue')


end
new_cell_GT=new_cell_gt;
uisave({'new_cell_GT'},strcat('./',gt_results_mat(1:end-4),'_w_ellipse',gt_results_mat(end-3:end)))

